#include <stdio.h>
#include <math.h>

/*
 *  Całkowanie numeryczne metodą prostokątów.
 *  Tomasz Dałek 2009-06-04
 */

#define DEBUG	0

double rectint(double (*pf)(double), double a, double b, double dx){
	/* Całka z funkcji pf, od a do b, z krokiem dx */
	
	double
	a1 = a,
	b1 = a + dx, 			// aktualnie iterowany przedział
	mid = (a1 + b1)/2.0,	// środek przedziału
	s=0.0;					// suma łączna pól przedziałów
	
	
	while (b1 <= b) {
		mid = (a1 + b1)/2.0;
		s += (*pf)(mid) * dx;
		
		if (DEBUG) {
			printf("a1=%f\n", a1);
			printf("b1=%f\n", b1);
			printf("mid=%f\n", mid);
		}
		
		a1 += dx;
		b1 += dx;
	}	
	return s;
	}


int main(void){
	printf("int_0^1 cos(x) dx = %.10f\n", rectint(&cos, 0.0, 1.0, 0.0001));
	printf("int_0^pi cos(x) dx = %.10f\n", rectint(&cos, 0.0, 3.1415, 0.0001));
	printf("int_0^1 exp(x) dx = %.10f\n", rectint(&exp, 0.0, 1.0, 0.0001));
	return 0;
}
